#ifndef _CSAfor2DB_hpp_
#define _CSAfor2DB_hpp_

// constants for readable DB-formats:
#define BUILTIN 1
#define FASTA 2
#define FASTA_MAXLINELENGTH 512

#include "CSA.h"
#include "Tools.h"
#include <stdlib.h>
#include <iostream>
#include <stdio.h>
#include <sys/stat.h>
#include <time.h>
#include <fstream>
using namespace std;


class CSAfor2DB {
public:
  // construct SA
  CSAfor2DB(char*, char*, int);

  // destructor
  virtual ~CSAfor2DB();

  // the suffix array (for t)
  CSA* csa;

  // the text (contains both databases)
  unsigned char* t;

  // number of DB entries in database 1
  ulong anz1;

  // number of DB entries in database 2
  ulong anz2;

  // number of DB entries in both DBs (sum of anz1 and anz2)
  ulong anz;

  // total length of DB (i.e., the SA has length+1 entries (0-byte))
  ulong length;

  // position in t where second database starts
  ulong middle;

  // free(text)
  void DeleteText();

private:

  // like fgets, but return number of chars
  int readln(char*, int, FILE*);

  // saves borders of DB-entries
  int* bound;
};

#endif
