/***************************************************************************
 *   Copyright (C) 2007 by Veli Mkinen                                    *
 *                                                                         *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.         *
 ***************************************************************************/

/*
 * Wavelet tree by Veli Mkinen,
 */

#ifndef _WAVELETTREE_H_
#define _WAVELETTREE_H_
#include <iostream>
#include <queue>
#include <iomanip>
#include "BitRank.h"
// #include "CompressedBitVector.h"
#include "Tools.h"

class WaveletTree {
private:
	ulong n;
	ulong maxlevel;
	//ulong* wtree; // concatenation of wavelet tree levels 
	ulong *leaves; // stores the leaf positions of characters 0..2^maxlevel-1
    BitRank* bitrank; // rank and select for the concatenation of wavelet tree levels 
public:            
    WaveletTree(ulong *, ulong, unsigned);
    WaveletTree(uchar *, ulong);
    ~WaveletTree();

   ulong rank(ulong c, ulong i);
    
   ulong select(ulong c, ulong j);
        
   bool IsCharAtPos(ulong c, ulong i);

   ulong charAtPos(ulong i);
   
//    double spaceInBits() {
//       return bitrank->spaceInBits()+bitrank->staticSpaceInBits()+sizeof(ulong)*8*(1ul<<maxlevel);      
//    }
};

#endif
